/* inetcus2.c */
   
#include <tos.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "inetcust.h"
#include "cookie.h"

/* Abfrage der Ether/Internetadresse durch einen speziellen Port */

#define TEST

#ifdef TEST
 #define EAP 0x1D09
#else
 #define EAP (*((int*)0xfffdf4L))  /* 16 Bit 00:00 */ 
#endif

#define _cookiejar	*(long *)0x5A0L

long set_cookiejar(COOKIE *);
void (* old_berr)();				    /* old bus error handler */

extern char Start;
extern INETCUST inetcust;
extern COOKIE   cookiejar[];
extern void berr_catch(void);		/* bus error handler for ST/STE */

char buffer[200];

#ifdef TEST 
long sp;						/* Stackpointer */
#endif

int memok;          /* Flag fuer Buserror aufgetreten */
int flag=0;					/* Flag fuer EAP-Ergnzung (y/n) */
int eap;            /* EAP-Wert */
int LPR=1;          /* Annahme, da LPR-Card da */
int rund = 0;				/* Zusatzvariable fr eap-Operationen */
char *rundstr=""; 	/* String dazu */

INETCUST   cust;		/* temporary custom struct */
#define MAXCOOKIES 11

void test_lpr_lance(void)     /* MR 10/94 */
{
  memok = 0; 
  eap = 0;
	
	old_berr = Setexc(2,(void (*)())(-1)); 
	
	Setexc(2,berr_catch); /* Buserror-Vektor auf berr_catch verbiegen */

#ifdef TEST       /* bei Abfrage von System von Systenvariablen */
  sp = Super(0L);	/* wird der Supervisormode bentigt */									
#endif
  
  /* EAP ansprechen, falls Error -> berr_catch setzt memok */
  eap = EAP;                        /* auf EAP zugreifen */
  
#ifdef TEST
  Super((void *)sp); 								
#endif  
    
  Setexc(2,old_berr);        /* richtigen Vektor wieder einsetzen */   
} 

int atoet(char *a,char *et)  /* char to ethernet-adress */
{
  int etbuf[6];
  if(sscanf(a,"%2x:%2x:%2x:%2x:%2x:%2x",&etbuf[0],&etbuf[1],&etbuf[2],&etbuf[3],&etbuf[4],&etbuf[5]) == 6)
  {
    et[0] = (char)etbuf[0];
    et[1] = (char)etbuf[1];
    et[2] = (char)etbuf[2];
    et[3] = (char)etbuf[3];
    
    if(flag) {
			rund  = (eap % 0x100); 
      et[4] = (char)((eap - rund) / 0x100);
   	  et[5] = (char)rund; 
		}
		else {
		  et[4] = (char)etbuf[4];
   	  et[5] = (char)etbuf[5];  /* bergibt Adresse nach et[] */
   	}  
    return(6);
  }	
  return(0);  /* Fehler aufgetreten ! */
}

long atoin(char *a)   /* char to internet-adress */
{
unsigned  n1,n2,n3,n4;
  
  if(sscanf(a,"%u.%u.%u.%u",&n1,&n2,&n3,&n4) == 4) {
    if(flag) {
      n4 = (unsigned int)(eap % 100);
    } 
    return(((unsigned long)n1<<24) + ((unsigned long)n2<<16) \
             + ((unsigned long)n3<<8) +(unsigned long)n4);
  }  
  return(0L); /* Fehler aufgetreten ! */
}

int loadinf(INETCUST *cust)
{
FILE *p_inf;
FILE *p_hosts;
char *p_tok;
char *p_arg;
int ntimeserv = 0;
int nnameserv = 0;


	p_inf=fopen("\\inetcust.inf","r");
	if(!p_inf) 
	  return(0);
	cust->magic = sizeof(INETCUST);
	while(fgets(buffer,(int)sizeof(buffer)-1,p_inf) != NULL)
	{
		p_tok = strtok(buffer,"= \n");
		if(!p_tok || !strlen(p_tok)) continue;
		p_arg = strtok(NULL," \n");
		
		if(!stricmp(p_tok,"HADDR"))
		{
		  /* Patch */
			flag=1;         /* hier Ergnzung des EAP */
			if(!atoet(p_arg,cust->haddr))
			{
				printf("invalid hardware address 'p_arg'\n");
				fclose(p_inf);
				return(0);
			}
 		}
		else if(!stricmp(p_tok,"HOSTIP"))
		{
		  /* Patch */
		  flag=1;    /* hier Ergnzug des EAP */
			cust->inaddr = atoin(p_arg);
			if(!cust->inaddr)
			{
				printf("invalid internet address 'p_arg'\n");
				fclose(p_inf);
				return(0);
			}
			flag=0;
		}
		else if(!stricmp(p_tok,"SUBNETBITS"))
		{
			cust->subnetbits = atoi(p_arg);
		}
		else if(!stricmp(p_tok,"TCPWINDOW"))
		{
			cust->tcpwnd = atoi(p_arg);
			if(!cust->tcplowater)
				cust->tcplowater = cust->tcpwnd/2;
		}
		else if(!stricmp(p_tok,"TCPLOWATER"))
		{
			cust->tcplowater = atoi(p_arg);
		}
		else if(!stricmp(p_tok,"NETMEM"))
		{
			cust->netmem = atol(p_arg);
		}
		else if(!stricmp(p_tok,"USER"))
		{
			strncpy(cust->username,p_arg,MAXUSERNAME-1);
		}
		else if(!stricmp(p_tok,"HOSTS"))
		{
			if((p_hosts = fopen(p_arg,"r")) == NULL)
			{
				printf("cannot find '%s'\n",p_arg);
				fclose(p_inf);
				return(0);
			}
			fclose(p_hosts);
			strncpy(cust->hosts,p_arg,sizeof(cust->hosts)-1);
		}
		else if(!stricmp(p_tok,"PASSWD"))
		{
			strncpy(cust->passwd,p_arg,sizeof(cust->passwd)-1);
		}
		else if(!stricmp(p_tok,"TZOFFS"))
		{
			cust->gmtoffs = atoi(p_arg);
		}
		else if(!stricmp(p_tok,"TZ"))
		{
			strncpy(cust->tzname,p_arg,sizeof(cust->tzname-1));
		}
		else if(!stricmp(p_tok,"TIMESERVER"))
		{
			if(ntimeserv > 1)
			{
				printf("no room for additional timeserver\n");
				fclose(p_inf);
				return(0);
			}
			if(!ntimeserv) cust->timeserver[1] = 0L;
			cust->timeserver[ntimeserv] = atoin(p_arg);
		    ntimeserv++;
		}
		else if(!stricmp(p_tok,"NAMESERVER"))
		{
			if(nnameserv > 2)
			{
				printf("no room for additional nameserver\n");
				fclose(p_inf);
				return(0);
			}
			if(!nnameserv) 
			{
				cust->nameserver[1] = 0L;
				cust->nameserver[2] = 0L;
			}
			cust->nameserver[nnameserv] = atoin(p_arg);
		    nnameserv++;
		}
		else if(!stricmp(p_tok,"GATEWAY"))
		{
			cust->gateway = atoin(p_arg);
		}
		else if(!stricmp(p_tok,"HOSTNAME"))
		{
		   
			strncpy(cust->hostname,p_arg,MAXHOSTNAME-1);
		}
		else if(!stricmp(p_tok,"DOMAIN"))
		{
			strncpy(cust->domainname,p_arg,MAXNAME-1);
		}
		else if(!stricmp(p_tok,"MAILHOST"))
		{
			strncpy(cust->mailhost,p_arg,MAXNAME-1);
		}
		else if(!stricmp(p_tok,"PRINTHOST"))
		{
			strncpy(cust->printhost,p_arg,MAXNAME-1);
		}
		else if(!stricmp(p_tok,"LOGINHOST"))
		{
			strncpy(cust->loginhost,p_arg,MAXNAME-1);
		}
		else if(!stricmp(p_tok,"PRINTER"))
		{
			strncpy(cust->printdev,p_arg,MAXHOSTNAME-1);
		}
		else if(!stricmp(p_tok,"FTPWIN"))
		{
			cust->ftpwin = atol(p_arg);
		}
		else
		{
			printf(" unknown keyword '%s'\n",p_tok);
		}
	}
	fclose(p_inf);
	
	if ( (strcmp(cust->hostname,"eikona")==0) && (LPR==1) ) 
	{ 
  	rund = eap % 0x10;    /* EAP auf letzte Stelle reduzieren */
	  itoa(rund,rundstr,10);  
	  strcat(cust->hostname,rundstr);
	}
	return(1);
}


COOKIE *get_cookiejar(void)
{
  register long superstack;
  register COOKIE *jar;

  superstack = Super((void *)0);
  jar = (COOKIE *)_cookiejar;  /* return address of cookiejar */
  Super((void*)superstack);
  return(jar);
}


COOKIE *add_cookie(long id,long val)
{
  register COOKIE *jar;
  jar = get_cookiejar();
  while(jar->id != ENDCOOKIE) jar++;  /* search end of cookiejar */
  jar->id = id;
  (jar+1)->val = jar->val;  /* keep size of jar */
  jar->val = val;
  (jar+1)->id = ENDCOOKIE;
  return(jar);
}


COOKIE *get_cookie(long id)
{
  register COOKIE *jar;
  if((jar = get_cookiejar()) == NULL) return(NULL);
  while(jar->id)
  {
    if(jar->id == id) return(jar);  /* find cookie */
    jar++;
  }
  return(NULL);
}


long set_cookiejar(COOKIE *newjar)
{
long superstack;
register COOKIE *jar;
register long i,c;

  jar = get_cookiejar();
  i=0;
  if(jar) for(; jar[i].id != ENDCOOKIE; i++);  /* get size of old jar */
  if(jar && jar[i].val > i) return(-jar[i].val); /* we have room */
  if(jar && jar[i].val >= MAXCOOKIES) return(0); /* occupied jar bigger than my pool */
  
  if(jar && newjar) for(c=0; c<i; c++)
  {  /* copy old jar */
    newjar[c].id = jar[c].id;
    newjar[c].val = jar[c].val;
  }
  newjar[i].id = ENDCOOKIE;  /* terminate new jar */
  newjar[i].val = MAXCOOKIES;

  superstack = Super((void *)0);
  _cookiejar = (long)newjar;  /* install new jar */
  Super((void*)superstack);
  return(MAXCOOKIES);
}


long main()
{
COOKIE *jar;
COOKIE *cookie;
long len = (char *)cookiejar - &Start + sizeof(BASPAG);
long jlen;
char str[10];

  test_lpr_lance(); /* EAP von LPR auslesen */
	if(memok)         /* Bus-Error -> */
	{	
		LPR=0;
		Cconws("\r\n TUM-LPR Ethernet-Card NOT found\r\n\a");
		Cconws("\r\n Try to continue with Riebl-Card\r\n\a");
	}
	else
	{
 	  Cconws("\r\n Set correct Ether/Internet-Adress by reading EAP \r\n\a");	
	} 
	jar = get_cookiejar();
	if(jar)
	{
		cookie = get_cookie(INETCUSTCOOKIE);
		if(cookie) 
		{
			memcpy(&cust,(void *)(cookie->val),sizeof(INETCUST));
			if(!loadinf(&cust))
				Cconws(" INETCUST: cannot load INETCUST.INF!\a\r\n");
			else
			{ /* Cookie-Val updaten */
				memcpy((void *)(cookie->val),&cust,sizeof(INETCUST));
				Cconws(" INETCUST updated !\r\n");
			}
			Pterm(1);
		}
	}
	jlen = set_cookiejar(cookiejar);
	if(!jlen) 
	{
		Cconws(" INETCUST: cannot add cookie!\r\n");
		Pterm(1);
	}
	if(jlen > 0) 
	{
		len += MAXCOOKIES*sizeof(COOKIE);
		Cconws("created new cookie jar\r\n");
	}
	memset(&inetcust,0,sizeof(INETCUST));
	if(!loadinf(&inetcust))
	{
		Cconws(" INETCUST: cannot load INETCUST.INF!\a\r\n");
		Pterm(1);
	}
	/* Structur INETCUST in Cookie-Val einhngen */
	add_cookie(INETCUSTCOOKIE,(long)&inetcust);
	
	Cconws(" INETCUST network environment installed\r\n using ");
	Cconws(ltoa(len,str,10));
	Cconws(" bytes\r\n");
	return(len);
}
